/*COMLIB*/
/*
	no core conditions cause specified function to be called with
	parameter FUBAR.  if no function is specified, NULL is
	returned.
*/
/**/
#define		M_RECORD	/* enable memory recording */
#undef		M_RECORD
#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		MAXREC		128
#define		M_FREED	0
#define		M_ALLOC	1
#define		M_TOTAL	2
#define		M_SHOWM	4
/**/
#ifndef		__TURBOC__
extern	void	free();
#endif		/*__TURBOC__*/
extern		KENV	kenv;
/*STATIC*/
static	FUNCP	xerr = (FUNCP) terror;
static	FUNCP	perr = (FUNCP) terror;
/**/
FUNCP	core_err(fu) 	/* set error function, return previous */
FUNCP	fu;
{
	xerr = fu;
	fu = perr;
	perr = xerr;
	return(fu);
}
#ifdef	M_RECORD
static	struct	MALLOC	{
		NOSIGN	bytes;		/* bytes allocated */
		char	*mbase;		/* pointer to allocated block */
		}	mtable[MAXREC];
static	NOSIGN	track = YES;
/**/
#endif
char	*
emalloc(nb,is)
NOSIGN	nb;			/* number of bytes */
char	*is;		/* error message */
{
	auto	char	*os = malloc( nb );
	if(os == NULL)	{
		errmsg("%s <no core> '%u'\n",is,nb);
		if(xerr != (FUNCP) NULL)	(*xerr)(FUBAR);
		}
#ifdef	M_RECORD
	else	{
		memset( os, 0, nb );
		if(track)	mrecord(M_ALLOC,is,os,nb);
#ifdef	DEBUG
	if(track)	mrecord(M_SHOWM,is,NULL,0);
#endif
		}
#endif
	return(os);
}
#ifdef	M_RECORD
mrecord(ty,is,os,nb)
NOSIGN	ty;		/* type */
char	*is;	/* calling routine */
char	*os;	/* base of core */
NOSIGN	nb;		/* number of bytes */
{
	auto	NOSIGN	ix;
	auto	NOSIGN	total = 0;
	switch(ty)	{
		case	M_ALLOC:
			for(ix = 0; ix < MAXREC; ix++)	{
				if(mtable[ix].mbase == NULL)	{
					mtable[ix].mbase = os;
					mtable[ix].bytes = nb;
					return(ZERO);
					}
				}
				errmsg("mrecord <too many segments>\n");
				track = NO;
				break;
		case	M_FREED:
			for(ix = 0; ix < MAXREC; ix++)	{
				if(mtable[ix].mbase == os)	{
					mtable[ix].mbase = NULL;
					mtable[ix].bytes = ZERO;
					return(ZERO);
					}
				}
				errmsg("mrecord <bad free>\n");
				break;
		case	M_TOTAL:
			for(ix = 0; ix < MAXREC; ix++)	{
				total += mtable[ix].bytes;
				}
				return(total);
		case	M_SHOWM:
			for(ix = 0; ix < MAXREC; ix++)	{
				if(mtable[ix].mbase)	{
					fprintf(stderr,"%3d ",ix);
					fprintf(stderr,"%6u ",mtable[ix].bytes);
					fprintf(stderr,"%6u ",mtable[ix].mbase);
					if(is)	fprintf(stderr,"%s",is);
					fprintf(stderr,"\n");
					}
				}
				break;
		default:	
				errmsg("mrecord <bad function>\n");
				break;
		}
	return(ZERO);
}
#else
mrecord()
{
}
#endif
char	*
erealloc(ps,nb,is)
char	*ps;	/* previous string */
char	*is;	/* name */
NOSIGN	nb;		/* bytes */
{
	if(ps == NULL)	{
		errmsg("erealloc <ps == NULL>\n");
		if(xerr != (FUNCP) NULL)	(*xerr)(FUBAR);
		return(ps);
		}
#ifdef	M_RECORD
	if(track)	mrecord(M_FREED,is,ps,0);
#ifdef	DEBUG
	if(track)	mrecord(M_SHOWM,is,ps,0);
#endif
#endif
	ps = realloc(ps, nb);
	if(ps == NULL)	{
		errmsg("%s <no core> '%u'\n",is,nb);
		if(xerr != (FUNCP) NULL)	(*xerr)(FUBAR);
		return(NULL);
		}
#ifdef	M_RECORD
	if(track)	mrecord(M_ALLOC,is,ps,nb);
#ifdef	DEBUG
	if(track)	mrecord(M_SHOWM,is,ps,0);
#endif
#endif
	return(ps);
}
char	*
free_if(os)
char	*os;
{
	if(os)	{
#ifdef	M_RECORD
		if(track)	mrecord(M_FREED,"free_if",os,0);
#ifdef	DEBUG
	if(track)	mrecord(M_SHOWM,"free_if",NULL,0);
#endif
#endif
		free(os);
		}
	return(NULL);
}
