/*
	89:02:10	added function prototypes, casts for large model
				compile
*/
/*
	This is a cobbled version of a pattern finding program
	floating around in the unix utilities.  I have added
	boolean logic and other elements.  This addition is
	far more complex than is needed.  Boolean operation is
	somewhat suspect for complex expressions but works well
	for simple pat1 && pat2 or pat1 || pat2 forms.
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
/**/
#define		DEFINES
#undef		FOLD
#define		FOLD	'\040'
#define		NOFOLD	'\000'
#define		HUGE	9999
#define		ANY	'.'
#define		LP	'('
#define		RP	')'
#define		BOL	'^'
#define		EOL	'$'
#define		KEY	'#'
#define		LIT	'c'
#define		BOW	'<'
#define		EOW	'>'
#define		AND	'&'
#define		OR	'|'
#define		NOT	'!'
#define		SRNG	'['
#define		ERNG	']'
#define		RNG	'-'
#define		CLS	'*'
#define		EOC		ZERO
#define		PATSIZ	BLKSIZ
#define		GOOD	0
#define		BAD	1
#define		KEYSIZ	128
/**/
struct	PATLOC	{
	char	*beg;
	char	*end;
};
static	struct	PATLOC	pat;
static	struct	PATLOC	xpat;
static	int		cp[PATSIZ],	*cpx,	*CPX;
static	char	kp[KEYSIZ],	*kpx,	*KPX;
static	char	xl[BLKSIZ],	*xlx,	*XLX;
static	int		nlp	=	0;
static	int		nrp	=	0;
static	int		pstatus	=	GOOD;
static	int		nocase	=	NO;	/* ignore case */
static	int		cflag	=	NOFOLD;
static	int		words	=	NO;	/* match on words */
static	int		oneline =	NO;
static	char	*psx;
static	char	*bsx;
/*EXTERN*/
#ifdef	CAN_PROTO
extern struct PATLOC *getpat(void);
extern int setwords(int);
extern int setnocase(int);
extern int setoneline(int);
extern int cpat(char *);
extern char *optset(char *);
extern int cpat1(void);
extern int popt(void);
extern int fpat(char *);
extern int fpat1(char *,int *);
extern char *fpat2(char *,int *,int);
extern int crng(void);
extern char *foldpat(char *);
extern char *xline(char *,char *,char *);
extern char *haskey(char *,char *);
extern int ckey(void);
extern void istpush(int *);
extern int *istpop(void);
extern void istclr(void);
extern void errmsg();
extern void terror();
#else	/*CAN_PROTO*/
extern struct PATLOC *getpat();
extern int setwords();
extern int setnocase();
extern int setoneline();
extern int cpat();
extern char *optset();
extern int cpat1();
extern int popt();
extern int fpat();
extern int fpat1();
extern char *fpat2();
extern int crng();
extern char *foldpat();
extern char *xline();
extern char *haskey();
extern int ckey();
extern void istpush();
extern int *istpop();
extern void istclr();
extern void errmsg();
extern void terror();
#endif	/*CAN_PROTO*/
static
lcmd()
{
	errmsg("cfpat <not implemented> 'lcmd'>\n");
	terror(FUBAR);
	return(0);
}
struct	PATLOC	*
getpat()
{
	return(&pat);
}
setwords(n)
int	n;
{
	n = (n == 0 || n == 1) ? n : 0;
	return(words = n);
}
setnocase(n)
int	n;
{
	n = (n == 0 || n == 1) ? n : 0;
	if(n) cflag = FOLD;
	else  cflag = NOFOLD;
	return(nocase = n);
}
setoneline(n)
int	n;
{
	n = (n == 0 || n == 1) ? n : 0;
	return(oneline = n);
}
cpat(is)	/* compile pattern code */
char	*is;
{
	nlp = nrp = 0;
	cpx = cp;
	*cpx = EOC;
	CPX = cpx + PATSIZ -10;
	kpx = kp;
	KPX = kp + KEYSIZ -1;
	xlx = xl;
	XLX = xl + BLKSIZ -1;
	pstatus = GOOD;
	*cpx++ = LP;
	*cpx++ = ' ';
	bsx=psx=is;
	setoneline(NO);
	setwords(NO);
	setnocase(NO);
/**/
	if(*psx == '?' && *(psx+1) == ZERO) {
		lcmd();
		return(pstatus=BAD);
		}
/**/
	optset(psx);
/**/
	if(nocase) foldpat(psx);
	while(pstatus == GOOD && cpx < CPX)
	{
		switch(*psx)
		{
		case	NULL:
				break;
		case	RP:
				nrp++;
				*cpx++ = *psx++;
				continue;
		case	LP:
				nlp++;
				*cpx++ = *psx++;
				*cpx++ = ' ';
				continue;
		case	KEY:	ckey();
				continue;
		case	AND:
		case	OR:
				*cpx++ = *psx;
				if(*psx == *(psx+1)) psx += 2;
				else psx++;
				continue;
		case	NOT:
			*cpx++ = *psx++;
			if(*psx == '(')
				{
				errmsg("<group negation not allowed>\n");
				return(pstatus = BAD);
				}
			continue;
		default:
			cpat1();
			continue;
		}
		break;
	}
	*cpx++ = RP;
	*cpx++ = EOC;
	if(cpx >= CPX) {errmsg("<pattern too large>\n");pstatus=BAD;}
	if(nlp != nrp) {errmsg("<parenthesis error>\n");pstatus=BAD;}
	if(pstatus == GOOD) 
		{
		popt();
		}
	else	cp[0] = EOC;
	return(pstatus);
}
char	*
optset(is)
char	*is;
{
	REG		char	*isx = is;
	REG		char	*osx = is;
	while(*isx != ZERO && pstatus == GOOD)
	if(*isx == '\\')
		switch(*++isx) 	{
		case	'l': 	setoneline(YES); isx += 1;
		when	'L': 	setoneline(NO); isx += 1;
		when	'w': 	setwords(YES); isx += 1;
		when	'W': 	setwords(NO); isx += 1;
		when	'i': 	setnocase(YES); isx += 1;
		when	'I': 	setnocase(NO); isx += 1;
						break;
		default:		*osx++ = '\\';
						*osx++ = *isx++;
						break;
		}
	else	{
		*osx++ = *isx++;
		}
	*osx = ZERO;
	return(is);
}
cpat1()
{
	REG	int	*lpx;
	int	*ccx;
	*cpx++ = LP;
	*cpx++ = ' ';
	lpx = NULL;
	if(words)	*cpx++ = BOW;
	while(cpx <CPX && pstatus == GOOD)
	{
		switch(*psx)
		{
		case	CLS:
/* ------------------------------------------------------------ */
			if(lpx == NULL)
				{ *cpx++ = LIT; *cpx++ = *psx++; continue; }
			ccx = cpx + 1;
			/* reset jump in range */
			if(*lpx == SRNG) *(lpx+1) = (int) cpx;
			for( ; cpx > lpx; cpx--) *cpx = *(cpx-1);
			*lpx = *psx++;
			cpx = ccx;
			lpx = NULL;
			continue;
/* ------------------------------------------------------------ */
		case	SRNG:	lpx = cpx;crng();continue;
		case	RP:
		case	NULL:
		case	AND:
		case	OR:	break;
		case	NOT:
		case	EOL:
		case	BOL:	lpx = NULL;*cpx++ = *psx++;continue;
		case	ANY:	lpx = cpx;*cpx++ = *psx++;continue;
		case	'\\':
			switch(*++psx)
			{
			case	EOW:
			case	BOW:	lpx = NULL;*cpx++ = *psx++;continue;
			default:
			break;
			}
		default:
		lpx = cpx;
		*cpx++ = LIT;
		*cpx++ = *psx++; continue;
		}
		break;
	}
	if(words)	*cpx++ = EOW;
	*cpx++ = RP;
	*cpx = EOC;
	return(pstatus);
}
popt()
{
	REG	int	*xpc;
	REG	int	*cpx	=	cp;
	while(*cpx != EOC)
	switch(*cpx) {
	case	LP:
		xpc = ++cpx;
		istpush(xpc);
		cpx++;
		break;
	case	RP:
		xpc = istpop();
		*xpc = (int)	cpx++;
		break;
	case	SRNG:
		cpx = (int *)	*(cpx+1);
		break;
	case	LIT:
		cpx += 2;
		break;
	default:
		cpx++;
		break;
	}
	return(pstatus);
}
fpat(is)	/* find pattern (initialization) */
char	*is;
{
	REG	int	res	=	0;
	istclr();
	pat.beg = pat.end = NULL;
	cpx = cp;
	res = fpat1(is,cpx);
	if(!res) pat.beg = pat.end = NULL;
	return(res);
}
fpat1(is,cp)	/* pattern logic looper */
int	*cp;
char	*is;
{
	REG	int	*cpx	=	cp;
	REG	int	res	=	0;
	REG	int	not	=	' ';
	auto		char	*bs	=	is;
	auto		char	*ts;
	for( ; ; )
	{
	switch(*cpx)
	{
	case	EOC:	return(res ? 1 : 0);
	case	KEY:
		ts = (char *)	*++cpx;
		if(*ts == KEY)
		{
		bs = is; ++cpx; res = 1; break;
		}
		if((int)(ts=haskey(is,ts)))
			{ bs = xline(xl,XLX,ts); ++cpx; res = 1; break; }
		else	 { res = 0; cpx = (int *) istpop(); break; }
	case	LP:	istpush((int *) *++cpx);
				++cpx;
				break;
	case	RP:	++cpx;
				break;
	case	AND:	if(!res) cpx = (int *) istpop();
			else ++cpx;
			break;
	case	OR:	if(res) cpx = (int *) istpop();
			else ++cpx;
			break;
	case	NOT:	not = *cpx++;break;
	default:
	xpat.beg = xpat.end = NULL;
	res = (int)	fpat2(bs,cpx,HUGE);
	if(res)
		{
		if(pat.beg == NULL || pat.beg > xpat.beg) pat.beg = xpat.beg;
		if(pat.end == NULL || pat.end < xpat.end) pat.end = xpat.end;
		}
	if(not == NOT)
		{
		if(res) res = NO;
		else 	res = YES;
		}
	not = ' ';
	cpx = (int *) istpop();
	break;
	}
	}
}
char	*
fpat2(is,cp,np)		/* loop through individual patterns */
char	*is;
int		*cp;
int		np;
{
	REG	char	*isx	=	is;
	REG	char	*tsx	=	NULL;
	REG	int		*cpx	=	cp;
	auto		int		tc		= 	0;
	auto		int		*xpc	=	0;
	auto		char	*xst	=	0;
	auto		int		nf		=	0;
	auto		int		found	=	0;
	while( *isx != ZERO )		/* step through line */
	{
	tsx = isx++;
	cpx = cp;
	tc = *tsx;
	/*
	if(nocase && isupper(tc)) tc = tolower(tc);
	if(*cpx == LIT && tc != *(cpx+1) ) 	continue;
	else	if(*cpx == BOW && isalnum(tc)) continue;
	else	if(*cpx == BOL && tc != '\n')	continue;
	*/
	while(*tsx != ZERO && np-- >= 1)	/* step through code */
		{
		tc = *tsx;
		if(nocase && isupper(tc)) tc = tolower(tc);
		found = NO;
		switch(*cpx)
		{
/* ------------------------------------------------------------ */
#define		CLOSURE
		case 	CLS:
			if(*(cpx+1) == LIT) xpc = cpx + 3;
			else	if(*(cpx+1) == ANY) xpc = cpx + 2;
			else	if(*(cpx+1) == SRNG) xpc = (int *) *(cpx+2);
			xst = tsx;
			while(1)
			{
			if(fpat2(xst,cpx+1,1)) xst++;
			else	break;
			}
			while(xst >= tsx)
			{
			if((fpat2(xst+1,xpc,HUGE)) != NULL)
				{ 
				return((char *)	1);
				}
			xst--;
			}
			cpx = xpc;
			continue;
/* ------------------------------------------------------------ */
		case	ERNG: cpx++;continue;
		case	SRNG:
			if(tc == '\n') {found = NO;break;}
			xpc = ++cpx;
			nf  = *++cpx;
			++cpx; 
			while(cpx < (int *)	*xpc)
			{
			if(*cpx == RNG)
				{
				if(tc >= *(cpx+1) && tc <= *(cpx+2))
					{found = YES;break;}
				else	cpx += 3;
				}
			else	if(*cpx == LIT)
				{
				if(*(cpx+1) == tc) {found = YES;break;}
				else	cpx += 2;
				}
			else	{
				errmsg("<bad code in range> cpx = %d\n",cpx);
				return(NULL);
				}
			}
			if(nf == '^') found = found >= 1 ? 0: 1;
			if(found)
				{
				if(xpat.beg == NULL) xpat.beg = tsx;
				xpat.end = tsx;
				tsx++;
				cpx = (int *) *xpc;
				continue;
				}
			else break;
/* ------------------------------------------------------------ */
		case	RP:	found = YES;break;
		case	EOW: case	BOW:
		if(isspace(*tsx) || ispunct(*tsx)) {cpx++;tsx++;continue;}
		else	break;
		case	EOL:
		found	=	NO;
		if(*tsx == '\n' || *tsx == ZERO) found = YES;
		break;
		case	BOL:
		if(*tsx == '\n' || *tsx == ZERO) {tsx++;cpx++;continue;}
		if(oneline) return(NULL);
		else	break;
		case	ANY:
		if(*tsx == '\n' || *tsx == ZERO) break;
		else	{
			if(xpat.beg == NULL) xpat.beg = tsx;
			xpat.end = tsx; tsx++; cpx++; continue;
			}
		case	LIT:
		if(tc == *++cpx)
				{
				tsx++;
				if(xpat.beg == NULL) xpat.beg = tsx-1;
				xpat.end = tsx-1;
				cpx++;continue;
				}
		else	break;
		default: errmsg("<bad code in pattern> cpx = %d\n",cpx);
		return(NULL);
		}
		break;		/* break code loop */
		}		/* end of while */
	if(np <= 0) 
		{
		if(tsx > isx)
			{
			return(tsx-1);
			}
		else return(NULL);
		}
	if(found == YES)	return(tsx);
	}			/* end of for */
	return(NULL);
}
crng()	/* compile [range or set] code */
{
	REG	int	*xpc;
	*cpx++ = *psx++;
	xpc = cpx;
	*cpx++ = ' ';
	if(*psx == '^') *cpx++ = *psx++;
	else	*cpx++ = ' ';
	if(*psx == ']') {*cpx++ = LIT; *cpx++ = *psx++;}
	while(*psx != ZERO && *psx != ERNG && cpx < CPX)
	if(isalnum(psx[0]) && *(psx+1) == '-' && isalnum(psx[2]) &&
		*(psx+2) > *psx)
		{
		*cpx++ = RNG;
		*cpx++ = *psx;
		*cpx++ = *(psx+2);
		psx += 3;
		}
	else	{
		*cpx++ = LIT;
		*cpx++ = *psx++;
		}
	if(*psx != ERNG) {errmsg("<missing ']'>\n");pstatus=BAD;}
	*xpc = (int) cpx;
	*cpx++ = *psx++;
	return(pstatus);
}
char	*
foldpat(is)	/* make sure pattern has no upper case items */
char	*is;
{
	REG	char	*isx	=	is;
	while(*isx != ZERO)
	if(isupper(*isx)) {*isx = tolower(*isx);isx++;}
	else	isx++;
	return(is);
}
char	*
xline(os,us,is)	/*	get one line beginning at is */
char	*os,	*us,	*is;
{
	REG	char	*isx	=	is;
	REG	char	*usx	=	us;
	REG	char	*osx	=	os;
	while(*isx == '\n') *osx++ = *isx++;
	while(*isx != ZERO && osx < usx && *isx != '\n') *osx++ = *isx++;
	*osx++ = *isx++;
	*osx++ = ZERO;
	return(os);
}
char	*
haskey(is,ks)	/* 	find key ks in line is */
char	*is,	*ks;
{
	REG	char	*isx	=	is;
	REG	char	*tsx;
	REG	char	*ksx;
	while(*isx != ZERO)
	{
	while(*isx != ZERO && *isx != '\n') isx++;
	for(tsx = isx++,ksx = ks; *ksx == *isx; ksx++,isx++) ;
	if(*ksx == ZERO &&
		 (isspace(*isx) || ispunct(*isx) || *isx == ZERO))
			return(tsx);
	}
	return(NULL);
}
ckey()
{
	if(*(psx-1) != '(')
		{
		errmsg("<no '(' before '#'>\n");
		return(pstatus=BAD);
		}
	*cpx++ = *psx++;
	*cpx++ = (int)	kpx;
	while(*psx != ZERO && cpx < CPX && 
		*psx != '&' && kpx < KPX) *kpx++ = *psx++;
		*kpx++ = ZERO;
	if(kpx >= KPX)
		{
		errmsg("<to many 'keys'>\n");pstatus=BAD;
		}
	if(*psx != '&')
		{
		errmsg("<no '&' after '#'>\n");pstatus=BAD;
		}
	return(pstatus);
}
#ifdef	TEST
main()
{
	char	ls[BLKSIZ];
	while(putchar('?'),gets(ls))
		switch(ls[0])	{
		case	'!':	system(ls+1);
		when	'?':	lcmd();
		when	'q':	exit(0);
		}
	exit(0);
}
#endif
#define		MAX_STACK	128
static		int	*istack[MAX_STACK];
static		int	nist;
void
istpush(ipx)
int		*ipx;
{
	istack[nist++] = ipx++;
	return;
}
int		*
istpop()
{
	return(istack[--nist]);
}
void
istclr()
{
	nist = 0;
	return;
}
